# remirepo/Fedora spec file for php-zendframework-zend-loader
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    78f11749ea340f6ca316bca5958eef80b38f9b6c
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-loader
%global php_home     %{_datadir}/php
%global library      Loader
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.6.0
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        %{name}-autoload.php
Source2:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
# From composer, "require-dev": {
#        "phpbench/phpbench": "^0.13",
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
# remirepo:4
%else
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit >= 5.7.27
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0"
Requires:       php(language) >= 5.6
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.1
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Loader provides different strategies for autoloading PHP classes.

You can include %{php_home}/Zend/autoload.php from
your application to use the Zend Framework.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src


%install
mkdir -p %{buildroot}%{php_home}/Zend
install -pm 644 %{SOURCE1} %{buildroot}%{php_home}/Zend/autoload.php

cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
: Deprecated autoloader
%{_bindir}/php -r '
    require "%{buildroot}%{php_home}/Zend/autoload.php";
    exit (class_exists("Zend\\Loader\\PluginClassLoader" ? 0 : 1));
'
: New autoloader
%{_bindir}/php -r '
    require "%{buildroot}%{php_home}/Zend/%{library}/autoload.php";
    exit (class_exists("Zend\\Loader\\PluginClassLoader" ? 0 : 1));
'

%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%dir %{php_home}/Zend
     %{php_home}/Zend/autoload.php
     %{php_home}/Zend/%{library}


%changelog
* Wed May  2 2018 Remi Collet <remi@remirepo.net> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP 5.6
- run upstream test suite
- sources from git snapshot

* Wed Dec  6 2017 Remi Collet <remi@remirepo.net> - 2.5.1-7
- use fedora/autoloader

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 2.5.1-4
- load container-interop and psr/http-message when present

* Mon May  2 2016 Remi Collet <remi@fedoraproject.org> - 2.5.1-3
- load dependencies out of Zend namespaces

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
